<?php
if ( ! class_exists( 'School_Education_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * School_Education_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class School_Education_Plugin_Activation_WPElemento_Importer {

        private static $school_education_instance;
        public $school_education_action_count;
        public $school_education_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$school_education_instance) ) {
            self::$school_education_instance = new self();
          }
          return self::$school_education_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'school_education_recommended_plugins', array($this, 'school_education_recommended_elemento_importer_plugins_array') );

            $school_education_actions                   = $this->school_education_get_recommended_actions();
            $this->school_education_action_count        = $school_education_actions['count'];
            $this->school_education_recommended_actions = $school_education_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function school_education_recommended_elemento_importer_plugins_array($school_education_plugins){
            $school_education_plugins[] = array(
                    'name'     => esc_html__('Mizan Demo Importor', 'school-education'),
                    'slug'     =>  'mizan-demo-importer',
                    'function' => 'Mizan_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the Mizan Demo Importor plugin for importing the demo content with Elementor.', 'school-education'),               
            );
            return $school_education_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'school-education-plugin-activation-script', esc_url(get_template_directory_uri()) . '/inc/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('school-education-plugin-activation-script', 'school_education_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'school-education'),
                    'activating' => esc_html__('Activating', 'school-education'),
                    'error' => esc_html__('Error', 'school-education'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=mizan-demo-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=mizandemoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'school-education-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function school_education_get_recommended_actions() {

            $school_education_act_count  = 0;
            $school_education_actions_todo = get_option( 'recommending_actions', array());

            $school_education_plugins = $this->school_education_get_recommended_plugins();

            if ($school_education_plugins) {
                foreach ($school_education_plugins as $school_education_key => $school_education_plugin) {
                    $school_education_action = array();
                    if (!isset($school_education_plugin['slug'])) {
                        continue;
                    }

                    $school_education_action['id']   = 'install_' . $school_education_plugin['slug'];
                    $school_education_action['desc'] = '';
                    if (isset($school_education_plugin['desc'])) {
                        $school_education_action['desc'] = $school_education_plugin['desc'];
                    }

                    $school_education_action['name'] = '';
                    if (isset($school_education_plugin['name'])) {
                        $school_education_action['title'] = $school_education_plugin['name'];
                    }

                    $school_education_link_and_is_done  = $this->school_education_get_plugin_buttion($school_education_plugin['slug'], $school_education_plugin['name'], $school_education_plugin['function']);
                    $school_education_action['link']    = $school_education_link_and_is_done['button'];
                    $school_education_action['is_done'] = $school_education_link_and_is_done['done'];
                    if (!$school_education_action['is_done'] && (!isset($school_education_actions_todo[$school_education_action['id']]) || !$school_education_actions_todo[$school_education_action['id']])) {
                        $school_education_act_count++;
                    }
                    $school_education_recommended_actions[] = $school_education_action;
                    $school_education_actions_todo[]        = array('id' => $school_education_action['id'], 'watch' => true);
                }
                return array('count' => $school_education_act_count, 'actions' => $school_education_recommended_actions);
            }

        }

        public function school_education_get_recommended_plugins() {

            $school_education_plugins = apply_filters('school_education_recommended_plugins', array());
            return $school_education_plugins;
        }

        public function school_education_get_plugin_buttion($slug, $name, $function) {
                $school_education_is_done      = false;
                $school_education_button_html  = '';
                $school_education_is_installed = $this->is_plugin_installed($slug);
                $school_education_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $school_education_is_activeted = (class_exists($function)) ? true : false;
                if (!$school_education_is_installed) {
                    $school_education_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $school_education_plugin_install_url = wp_nonce_url($school_education_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $school_education_button_html        = sprintf('<a class="school-education-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($school_education_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'school-education'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'school-education')
                    );
                } elseif ($school_education_is_installed && !$school_education_is_activeted) {

                    $school_education_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($school_education_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $school_education_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $school_education_button_html = sprintf('<a class="school-education-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($school_education_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'school-education'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'school-education')
                    );
                } elseif ($school_education_is_activeted) {
                    $school_education_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'school-education'));
                    $school_education_is_done     = true;
                }

                return array('done' => $school_education_is_done, 'button' => $school_education_button_html);
            }
        public function is_plugin_installed($slug) {
            $school_education_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $school_education_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($school_education_installed_plugins[$school_education_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $school_education_keys = array_keys($this->get_installed_plugins());
            foreach ($school_education_keys as $school_education_key) {
                if (preg_match('|^' . $slug . '/|', $school_education_key)) {
                    return $school_education_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
School_Education_Plugin_Activation_WPElemento_Importer::get_instance();